package ch.unisg.tapas.auctionhouse.application.port.in;

import ch.unisg.tapas.auctionhouse.domain.Auction;
import ch.unisg.tapas.auctionhouse.domain.AuctionHouseDiscoveryInformation;
import ch.unisg.tapas.common.SelfValidating;
import lombok.Value;

import javax.validation.constraints.NotNull;

@Value
public class AuctionHouseDiscoveryCommand extends SelfValidating<AuctionHouseDiscoveryCommand> {
    @NotNull
    private final AuctionHouseDiscoveryInformation.AuctionHouseUri auctionHouseUri;

    @NotNull
    private final AuctionHouseDiscoveryInformation.WebSubUri webSubUri;

    @NotNull
    private final AuctionHouseDiscoveryInformation.TaskTypes taskTypes;

    @NotNull
    private final AuctionHouseDiscoveryInformation.TimeStamp timeStamp;

    //Didn't put @NotNull here since the GroupName is not required
    private final AuctionHouseDiscoveryInformation.GroupName groupName;

    public AuctionHouseDiscoveryCommand(AuctionHouseDiscoveryInformation.AuctionHouseUri auctionHouseUri,
                                        AuctionHouseDiscoveryInformation.WebSubUri webSubUri,
                                        AuctionHouseDiscoveryInformation.TaskTypes taskTypes,
                                        AuctionHouseDiscoveryInformation.TimeStamp timeStamp,
                                        AuctionHouseDiscoveryInformation.GroupName groupName) {
        this.auctionHouseUri = auctionHouseUri;
        this.webSubUri = webSubUri;
        this.taskTypes = taskTypes;
        this.timeStamp = timeStamp;
        this.groupName = groupName;

        this.validateSelf();
    }
}
